# coding: utf-8

"""
    This class is auto generated from the Infobip OpenAPI specification
    through the OpenAPI Specification Client API libraries (Re)Generator (OSCAR),
    powered by the OpenAPI Generator (https://openapi-generator.tech).
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, constr, validator
from infobip_cpaasx.models.number_price import NumberPrice
from infobip_cpaasx.models.numbers_edit_permissions import NumbersEditPermissions
from infobip_cpaasx.models.numbers_voice_setup import NumbersVoiceSetup


class NumberResponse(BaseModel):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    number_key: Optional[StrictStr] = Field(None, alias="numberKey")
    number: Optional[StrictStr] = None
    country: Optional[StrictStr] = None
    country_name: Optional[StrictStr] = Field(None, alias="countryName")
    type: Optional[StrictStr] = None
    capabilities: Optional[List[StrictStr]] = None
    shared: Optional[StrictBool] = None
    price: Optional[NumberPrice] = None
    network: Optional[StrictStr] = None
    keywords: Optional[List[StrictStr]] = None
    voice_setup: Optional[NumbersVoiceSetup] = Field(None, alias="voiceSetup")
    reservation_status: Optional[StrictStr] = Field(None, alias="reservationStatus")
    additional_setup_required: Optional[StrictBool] = Field(
        None, alias="additionalSetupRequired"
    )
    edit_permissions: Optional[NumbersEditPermissions] = Field(
        None, alias="editPermissions"
    )
    application_id: Optional[constr(strict=True, max_length=255, min_length=0)] = Field(
        None,
        alias="applicationId",
        description="ID of the Application that would be associated with the number.",
    )
    entity_id: Optional[constr(strict=True, max_length=255, min_length=0)] = Field(
        None,
        alias="entityId",
        description="ID of the Entity that would be associated with the number.",
    )
    __properties = [
        "numberKey",
        "number",
        "country",
        "countryName",
        "type",
        "capabilities",
        "shared",
        "price",
        "network",
        "keywords",
        "voiceSetup",
        "reservationStatus",
        "additionalSetupRequired",
        "editPermissions",
        "applicationId",
        "entityId",
    ]

    @validator("type")
    def type_validate_enum(cls, v):
        if v is None:
            return v

        if v not in (
            "VIRTUAL_LONG_NUMBER",
            "SHORT_CODE",
            "SIM_HOSTING",
            "VIRTUAL_SIM_HOSTING",
            "VIRTUAL_LONG_NUMBER_CALL_TRIGGER",
            "SHORT_CODE_USSD",
            "WHATSAPP",
            "VIBER",
            "VIBER_VOICE",
            "FACEBOOK",
        ):
            raise ValueError(
                "must validate the enum values ('VIRTUAL_LONG_NUMBER', 'SHORT_CODE', 'SIM_HOSTING', 'VIRTUAL_SIM_HOSTING', 'VIRTUAL_LONG_NUMBER_CALL_TRIGGER', 'SHORT_CODE_USSD', 'WHATSAPP', 'VIBER', 'VIBER_VOICE', 'FACEBOOK')"
            )
        return v

    @validator("capabilities")
    def capabilities_validate_enum(cls, v):
        if v is None:
            return v

        for enum_value in v:
            if enum_value not in ("SMS", "VOICE", "MMS"):
                raise ValueError("must validate the enum values ('SMS', 'VOICE', 'MMS')")
        return v

    @validator("reservation_status")
    def reservation_status_validate_enum(cls, v):
        if v is None:
            return v

        if v not in ("PENDING", "BILLING_FAILED", "ERROR"):
            raise ValueError(
                "must validate the enum values ('PENDING', 'BILLING_FAILED', 'ERROR')"
            )
        return v

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> NumberResponse:
        """Create an instance of NumberResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of price
        if self.price:
            _dict["price"] = self.price.to_dict()
        # override the default output from pydantic by calling `to_dict()` of voice_setup
        if self.voice_setup:
            _dict["voiceSetup"] = self.voice_setup.to_dict()
        # override the default output from pydantic by calling `to_dict()` of edit_permissions
        if self.edit_permissions:
            _dict["editPermissions"] = self.edit_permissions.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> NumberResponse:
        """Create an instance of NumberResponse from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return NumberResponse.parse_obj(obj)

        _obj = NumberResponse.parse_obj(
            {
                "number_key": obj.get("numberKey"),
                "number": obj.get("number"),
                "country": obj.get("country"),
                "country_name": obj.get("countryName"),
                "type": obj.get("type"),
                "capabilities": obj.get("capabilities"),
                "shared": obj.get("shared"),
                "price": NumberPrice.from_dict(obj.get("price"))
                if obj.get("price") is not None
                else None,
                "network": obj.get("network"),
                "keywords": obj.get("keywords"),
                "voice_setup": NumbersVoiceSetup.from_dict(obj.get("voiceSetup"))
                if obj.get("voiceSetup") is not None
                else None,
                "reservation_status": obj.get("reservationStatus"),
                "additional_setup_required": obj.get("additionalSetupRequired"),
                "edit_permissions": NumbersEditPermissions.from_dict(
                    obj.get("editPermissions")
                )
                if obj.get("editPermissions") is not None
                else None,
                "application_id": obj.get("applicationId"),
                "entity_id": obj.get("entityId"),
            }
        )
        return _obj
