# coding: utf-8

"""
    This class is auto generated from the Infobip OpenAPI specification
    through the OpenAPI Specification Client API libraries (Re)Generator (OSCAR),
    powered by the OpenAPI Generator (https://openapi-generator.tech).
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr
from infobip_cpaasx.models.sms_sending_speed_limit import SmsSendingSpeedLimit
from infobip_cpaasx.models.sms_textual_message import SmsTextualMessage
from infobip_cpaasx.models.sms_tracking import SmsTracking
from infobip_cpaasx.models.sms_url_options import SmsUrlOptions


class SmsAdvancedTextualRequest(BaseModel):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    bulk_id: Optional[StrictStr] = Field(
        None,
        alias="bulkId",
        description="Unique ID assigned to the request if messaging multiple recipients or sending multiple messages via a single API request. If not provided, it will be auto-generated and returned in the API response. Typically, used to fetch [delivery reports](#channels/sms/get-outbound-sms-message-delivery-reports) and [message logs](#channels/sms/get-outbound-sms-message-logs).",
    )
    messages: List[SmsTextualMessage] = Field(
        ...,
        description="An array of message objects of a single message or multiple messages sent under one bulk ID.",
    )
    sending_speed_limit: Optional[SmsSendingSpeedLimit] = Field(
        None, alias="sendingSpeedLimit"
    )
    url_options: Optional[SmsUrlOptions] = Field(None, alias="urlOptions")
    tracking: Optional[SmsTracking] = None
    __properties = ["bulkId", "messages", "sendingSpeedLimit", "urlOptions", "tracking"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SmsAdvancedTextualRequest:
        """Create an instance of SmsAdvancedTextualRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in messages (list)
        _items = []
        if self.messages:
            for _item in self.messages:
                if _item:
                    _items.append(_item.to_dict())
            _dict["messages"] = _items
        # override the default output from pydantic by calling `to_dict()` of sending_speed_limit
        if self.sending_speed_limit:
            _dict["sendingSpeedLimit"] = self.sending_speed_limit.to_dict()
        # override the default output from pydantic by calling `to_dict()` of url_options
        if self.url_options:
            _dict["urlOptions"] = self.url_options.to_dict()
        # override the default output from pydantic by calling `to_dict()` of tracking
        if self.tracking:
            _dict["tracking"] = self.tracking.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SmsAdvancedTextualRequest:
        """Create an instance of SmsAdvancedTextualRequest from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return SmsAdvancedTextualRequest.parse_obj(obj)

        _obj = SmsAdvancedTextualRequest.parse_obj(
            {
                "bulk_id": obj.get("bulkId"),
                "messages": [
                    SmsTextualMessage.from_dict(_item) for _item in obj.get("messages")
                ]
                if obj.get("messages") is not None
                else None,
                "sending_speed_limit": SmsSendingSpeedLimit.from_dict(
                    obj.get("sendingSpeedLimit")
                )
                if obj.get("sendingSpeedLimit") is not None
                else None,
                "url_options": SmsUrlOptions.from_dict(obj.get("urlOptions"))
                if obj.get("urlOptions") is not None
                else None,
                "tracking": SmsTracking.from_dict(obj.get("tracking"))
                if obj.get("tracking") is not None
                else None,
            }
        )
        return _obj
