# coding: utf-8

"""
    This class is auto generated from the Infobip OpenAPI specification
    through the OpenAPI Specification Client API libraries (Re)Generator (OSCAR),
    powered by the OpenAPI Generator (https://openapi-generator.tech).
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr, validator


class SmsTurkeyIysOptions(BaseModel):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    brand_code: Optional[StrictInt] = Field(
        None,
        alias="brandCode",
        description="Brand code is an ID of the company based on a company VAT number. If not provided in request, default value is used from your Infobip account.",
    )
    recipient_type: StrictStr = Field(
        ...,
        alias="recipientType",
        description="Recipient Type must be `TACIR` or `BIREYSEL`.",
    )
    __properties = ["brandCode", "recipientType"]

    @validator("recipient_type")
    def recipient_type_validate_enum(cls, v):
        if v not in ("BIREYSEL", "TACIR"):
            raise ValueError("must validate the enum values ('BIREYSEL', 'TACIR')")
        return v

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SmsTurkeyIysOptions:
        """Create an instance of SmsTurkeyIysOptions from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SmsTurkeyIysOptions:
        """Create an instance of SmsTurkeyIysOptions from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return SmsTurkeyIysOptions.parse_obj(obj)

        _obj = SmsTurkeyIysOptions.parse_obj(
            {
                "brand_code": obj.get("brandCode"),
                "recipient_type": obj.get("recipientType"),
            }
        )
        return _obj
