# coding: utf-8

"""
    This class is auto generated from the Infobip OpenAPI specification
    through the OpenAPI Specification Client API libraries (Re)Generator (OSCAR),
    powered by the OpenAPI Generator (https://openapi-generator.tech).
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr
from infobip_cpaasx.models.message_error import MessageError
from infobip_cpaasx.models.message_price import MessagePrice
from infobip_cpaasx.models.message_status import MessageStatus


class SmsWebhookOutboundReport(BaseModel):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    bulk_id: Optional[StrictStr] = Field(
        None,
        alias="bulkId",
        description="Unique ID attributed to  messages sent to multiple recipients.",
    )
    message_id: Optional[StrictStr] = Field(
        None,
        alias="messageId",
        description="Unique SMS ID for individual messages sent.",
    )
    to: Optional[StrictStr] = Field(None, description="Recipient number.")
    sent_at: Optional[datetime] = Field(
        None, alias="sentAt", description="Date and time the message was sent."
    )
    done_at: Optional[datetime] = Field(
        None,
        alias="doneAt",
        description="Date and time the message was finished processing by Infobip.  This is when the message was delivered to the specified destination.",
    )
    sms_count: Optional[StrictInt] = Field(
        None,
        alias="smsCount",
        description="Long SMS messages have a character limit on how much can be sent over one message.  Longer messages will be split up into multiple messages and sent separately.  This is the total count of messages one SMS was sent over.",
    )
    mcc_mnc: Optional[StrictStr] = Field(
        None, alias="mccMnc", description="Mobile country and network codes."
    )
    callback_data: Optional[StrictStr] = Field(
        None,
        alias="callbackData",
        description="The callback data sent through the callbackData field in your fully featured SMS message.",
    )
    price: Optional[MessagePrice] = None
    status: Optional[MessageStatus] = None
    error: Optional[MessageError] = None
    __properties = [
        "bulkId",
        "messageId",
        "to",
        "sentAt",
        "doneAt",
        "smsCount",
        "mccMnc",
        "callbackData",
        "price",
        "status",
        "error",
    ]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SmsWebhookOutboundReport:
        """Create an instance of SmsWebhookOutboundReport from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True, exclude={}, exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of price
        if self.price:
            _dict["price"] = self.price.to_dict()
        # override the default output from pydantic by calling `to_dict()` of status
        if self.status:
            _dict["status"] = self.status.to_dict()
        # override the default output from pydantic by calling `to_dict()` of error
        if self.error:
            _dict["error"] = self.error.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> SmsWebhookOutboundReport:
        """Create an instance of SmsWebhookOutboundReport from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return SmsWebhookOutboundReport.parse_obj(obj)

        _obj = SmsWebhookOutboundReport.parse_obj(
            {
                "bulk_id": obj.get("bulkId"),
                "message_id": obj.get("messageId"),
                "to": obj.get("to"),
                "sent_at": obj.get("sentAt"),
                "done_at": obj.get("doneAt"),
                "sms_count": obj.get("smsCount"),
                "mcc_mnc": obj.get("mccMnc"),
                "callback_data": obj.get("callbackData"),
                "price": MessagePrice.from_dict(obj.get("price"))
                if obj.get("price") is not None
                else None,
                "status": MessageStatus.from_dict(obj.get("status"))
                if obj.get("status") is not None
                else None,
                "error": MessageError.from_dict(obj.get("error"))
                if obj.get("error") is not None
                else None,
            }
        )
        return _obj
